/*----------------------------------------------------------------------*/
/*  BoardBox - is a component that contains a picture of a Board 
                                                                        */
/*----------------------------------------------------------------------*/
/*             Jim Morey  -  morey@math.ubc.ca  -  Mar 10,1996          */
/*----------------------------------------------------------------------*/
  
import java.awt.*;
import java.lang.*;

/*----------------------------------------------------------------------*/

public class BoardBox extends Canvas {
  private Board board;
  private int x,y;
  private Solid solid;
  private GroupGraph group;

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  BoardBox(Board board_,Solid solid_,GroupGraph group_,int wid,int hei) {
    setBackground(Color.lightGray); 
    setForeground(Color.black);
    board = board_;
    solid = solid_;
    group = group_;
    resize(wid,hei);
    x = wid/2 - (board.boundary[0][0]+board.boundary[1][0])/2;
    y = hei/2 - (board.boundary[0][1]+board.boundary[1][1])/2;
    
    repaint();
  }

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  public void paint(Graphics g) {
    board.Draw(g,solid,group,x,y,false); 
  }
}
