/*----------------------------------------------------------------------*/
/*  Title -- this object draws a centred string (using wid,hei) in a
        component.  
                                                                        */
/*----------------------------------------------------------------------*/
/*             Jim Morey  -  morey@math.ubc.ca  -  Mar 10,1996          */
/*----------------------------------------------------------------------*/
  
import java.awt.*;
import java.lang.*;

/*----------------------------------------------------------------------*/

public class Title extends Canvas {
  public String title;
  public Font font;
  public int x,y;

  private Component comp;

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  Title(Component comp_,String title_,int wid,int hei) {
    resize(wid,hei);
    comp=comp_;
    
    title = new String(title_);
    font = new Font("TimesRoman",Font.BOLD,30);
    centre();
    repaint();
  }

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  public void centre() {
    FontMetrics fm = comp.getFontMetrics(font);
    x=(size().width-fm.stringWidth(title))/2;
    y=(size().height-fm.getHeight())/2+fm.getAscent();
  }

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  public void paint(Graphics g) {
    g.setFont(font); 
    g.drawString(title,x,y);
  }
}
