// LoginWindow.java
// A popup window to prompt for a username and password
import java.awt.*;

public class LoginWindow extends FixedFrame
{
	Component parent;
	Button ok, can;
	TextField name, pass;

	LoginWindow(Component p)
	{
	super(new Dimension(250, -1));
	parent = p;
	setLayout(new BorderLayout());

	Panel top = new Panel();
	top.setLayout(new BorderLayout());
	Panel left = new Panel();
	left.setLayout(new GridLayout(2,1));
	left.add(new Label("Username"));
	left.add(new Label("Password"));
	top.add("West",left);
	Panel right = new Panel();
	right.setLayout(new GridLayout(2,1));
	right.add(name = new TextField());
	right.add(pass = new TextField());
	pass.setEchoCharacter('*');
	top.add("Center",right);
	add("North",top);

	Panel but = new Panel();
	but.setLayout(new FlowLayout(FlowLayout.RIGHT));
	but.add(ok = new Button("Ok"));
	but.add(can = new Button("Cancel"));
	add("South",but);

	setTitle("JFS login");
	setResizable(false);
	pack();
	show();
	}

	String getname()
	{
	return name.getText();
	}

	String getpass()
	{
	return pass.getText();
	}

	public boolean handleEvent(Event evt)
	{
	if (evt.id == Event.ACTION_EVENT) {
		if (evt.target == name)
			pass.requestFocus();
		else if (evt.target == ok || evt.target == pass) {
			parent.postEvent(
				new Event(this, Event.ACTION_EVENT, "Ok"));
			dispose();
			}
		}
	else if (evt.target == can || evt.id == Event.WINDOW_DESTROY) {
		parent.postEvent(new Event(this, Event.ACTION_EVENT, "Cancel"));
		dispose();
		}
	return super.handleEvent(evt);
	}
}

// MessageWindow
// A useful class for creating pop-up messages
class MessageWindow extends FixedFrame
{
	Button ok;
	MultiLabel lab;

	MessageWindow(String title, String msg)
	{
	setLayout(new BorderLayout());
	add("Center",lab = new MultiLabel(msg));
	Panel bp = new Panel();
	bp.setLayout(new FlowLayout());
	bp.add(ok = new Button("Ok"));
	add("South",bp);

	setTitle(title);
	setResizable(false);
	pack();
	show();
	}

	public boolean action(Event evt, Object obj)
	{
	if (evt.target == ok) dispose();
	return true;
	}
}


// ErrorWindow
// A window for displaying pop-up error messages
class ErrorWindow extends MessageWindow
{
	ErrorWindow(String m)
	{
	super("Error",m);
	}
}

