##############################################################################
#
#  Copyright (c) 1996 by Dow Jones and Company, Inc.
#
#  TestPjLauncher.mak
#
#       Makefile for testing PjLauncher.
#
#  Authors:
#
#      rphall   Rick Hall
#
#  Version Ident:
#
#      $Header: /PjJavaClient/src/pj/applet/PjLauncher.mak 2     1/21/96 6:27p Rphall $
#
#  History:
#
#      15-Jan-96    rphall  Initial creation
#
##############################################################################

# REQUIRED: define where master makefiles can be found.
# (Make definition conditional so that it can be overridden on a command line.)
!IF "$(JAVAMAKEDIR)" == ""
JAVAMAKEDIR=.\..\..
!ENDIF
!IF "$(CFG)" == ""
CFG=Java Debug
!ENDIF
!IF "$(JAVACLASSDIR)" == ""
JAVACLASSDIR=.\classes
!ENDIF
!IF "$(JAVADOCDIR)" == ""
JAVADOCDIR=.\apidocs
!ENDIF

# Include default macro definitions and generalized rules
!INCLUDE $(JAVAMAKEDIR)\defaults.mak

# List your classes here, one per line, with a backslash for continuation
CLASSES=PjLauncher.class

# List the classes you want documented, one per line, with backslashes
APIDOCS=pj.applet.PjLauncher.html

# The default target for the build. (The first target is the project default.)
binary : $(JAVACLASSDIR) $(CLASSES)
	for %f in ($(CLASSES)) do copy %f $(JAVACLASSDIR)

all : $(JAVACLASSDIR) $(JAVADOCDIR) $(JAVADOCDIR)/images $(CLASSES) $(APIDOCS)
	for %f in ($(CLASSES)) do copy %f $(JAVACLASSDIR)
	for %f in ($(APIDOCS)) do copy %f $(JAVADOCDIR)

# Include other targets
!INCLUDE $(JAVAMAKEDIR)\dtargets.mak

# List dependencies here (particularly private class dependencies)

PjLauncher.class : PjLauncher.java

pj.applet.PjLauncher.html : PjLauncher.html
