/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.


    @(#)ColumnSingleView.java  0.00 01-Jan-96

A column that only has one view, all though it may be made up of many stories
 those stories are presented all on one screen. Two of the TJI Columns are
 this way.   See HeadlineSection.

    Authors:
		        
        Ted      Ted Skolnick
        

    Version Ident:

        $Header: /PjJavaClient/src/pj/awt/Column.java 3     2/11/96 4:39p Rphall $

    History:

        0.00 20-Mar-96  Ted Skolnick.      Initial Creation
        
        

---------------------------------------------------------------------------*/

package pj.awt;

import pj.awt.Column;
import pj.io.Paper;



/**
 * A column that only has one view, all though it may be made up of many stories
 *	those stories are presented all on one screen. Two of the TJI Columns are
 *	this way.   See HeadlineSection.
 *
 * @version 0.00 19-Mar-96
 * @author  Ted S.
*/
public class ColumnSingleView extends Column
    {

    // --- Public constructors

    /**
     * Construct a Column as a standalone page.
     * @param pagename  The name of the standalone page.
     * @param section   The name of the observed section.
     * @param p         The paper that contains the observed section.
    */
    public ColumnSingleView(String pagename, String section, Paper p)
        {
        super(pagename, section, p);        
        }

    /**
     * Construct a Column as a page component.
     * @param section   The name of the observed section.
     * @param paper     The paper that contains the observed section.
    */
    public ColumnSingleView(String section, Paper paper)
        { 
		super(section,paper); 
		}

    // --- Public operations

    /**
     * @return The number of views for this Column
    */
    public int countViews()
        { 
		return 1; 
		}

    } // ColumnSingleView
