/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.



    @(#)IncompatiblePaperStoryException.java    o.00 20-Dec-95


        An exception that signals an incompatibility between a PaperStory
        and some other object, typically a StoryContainer


    Authors:

        rphall      Rick Hall


    Version Ident:

        $Header$


    History:

        12/20/95    rphall      Initial Creation


---------------------------------------------------------------------------*/

package pj.io;

/**
 * Signals an attempt to add a PaperStory of the wrong type.
 * @version 0.00, 20-Dec-95
 * @author 	Rick Hall
 */
public class IncompatiblePaperStoryException extends Exception
    {


    // --- Public constructors

    /**
     * Constructs a IncompatiblePaperStoryException with no detail message.  A
     * detail message is a String that describes this particular 
     * exception.
     */
    public IncompatiblePaperStoryException()
        {
        }

    /**
     * Constructs a IncompatiblePaperStoryException with the specified detail 
     * message.  A detail message is a String that describes this 
     * particular exception.
     * @param msg the detail message
     */
    public IncompatiblePaperStoryException(String msg)
        { 
        super(msg); 
        }

    } // IncompatiblePaperStoryException
