##############################################################################
#
#  Copyright (c) Dow Jones and Company. 1994,1995. All Rights Reserved.
#
#  StoryParser.mak
#
#      makefile for a Personal Journal story parser
#
#  Authors:
#
#      rphall   Rick Hall
#
#  Version Ident:
#
#      $Header$
#
#  History:
#
#      12/23/95	rphall  initial creation
#
##############################################################################

# REQUIRED: define where master makefiles can be found.
# (Make definition conditional so that it can be overridden on a command line.)
!IF "$(JAVAMAKEDIR)" == ""
JAVAMAKEDIR=.\..\..
!ENDIF
!IF "$(CFG)" == ""
CFG=Java Debug
!ENDIF
!IF "$(JAVACLASSDIR)" == ""
JAVACLASSDIR=c:\http
!ENDIF

# Include default macro definitions and generalized rules
!INCLUDE $(JAVAMAKEDIR)\defaults.mak

# List your classes here, one per line, with a backslash for continuation
CLASSES=Paper.class             \
        PaperStory.class        \
        StoryContainer.class    \
        StoryScanner.class      \
        StoryParser.class       \
        StoryParserSymbols.class\
        TestStoryParser.class

# List the classes you want documented, one per line, with backslashes
APIDOCS=StoryScanner.html   \
        StoryParser.html

# The default target for the build. (The first target is the project default.)
all: $(JAVACLASSDIR) $(JAVADOCDIR) $(JAVADOCDIR)/images $(CLASSES) $(APIDOCS)
	for %f in ($(CLASSES)) do copy %f $(JAVACLASSDIR)
	for %f in ($(APIDOCS)) do copy %f $(JAVADOCDIR)

# Include other targets
!INCLUDE $(JAVAMAKEDIR)\dtargets.mak

# List dependencies here (particularly private class dependencies)

TestStoryParser.class : StoryParser.class Paper.class

Paper.class :           PaperStory.class PaperSection.class

StoryScanner.class :    StoryParserSymbols.class PaperStory.class
        
StoryParser.class :     StoryParserSymbols.class PaperStory.class \
                        StoryScanner.class StoryContainer.class
