##############################################################################
#
#  Copyright (c) 1996 by Dow Jones and Company, Inc.
#
#  Lang.mak
#
#      Makefile for a Personal Journal Lang package
#
#  Authors:
#
#      rphall   Rick Hall
#
#  Version Ident:
#
#      $Header: /PjJavaClient/src/pj/lang/Lang.mak 3     1/30/96 6:21p Rphall $
#
#  History:
#
#      19-Jan-96	rphall  initial creation
#
##############################################################################

# REQUIRED: define where master makefiles can be found.
# (Make definition conditional so that it can be overridden on a command line.)
!IF "$(JAVAMAKEDIR)" == ""
JAVAMAKEDIR=.\..\..
!ENDIF
!IF "$(CFG)" == ""
CFG=Java Debug
!ENDIF
!IF "$(JAVACLASSDIR)" == ""
JAVACLASSDIR=.\classes
!ENDIF
!IF "$(JAVADOCDIR)" == ""
JAVADOCDIR=.\apidocs
!ENDIF

# Include default macro definitions and generalized rules
!INCLUDE $(JAVAMAKEDIR)\defaults.mak

# List your classes here, one per line, with a backslash for continuation
CLASSES=EmptySecurityManager.class

# List the classes you want documented, one per line, with backslashes
APIDOCS=Packages-pj.lang.html \
        pj.lang.EmptySecurityManager.html

# The default target for the build. (The first target is the Lang default.)
binary : $(JAVACLASSDIR) $(CLASSES)
	for %f in ($(CLASSES)) do copy %f $(JAVACLASSDIR)

documentation : $(JAVADOCDIR) $(JAVADOCDIR)/images $(APIDOCS)
	for %f in ($(APIDOCS)) do copy %f $(JAVADOCDIR)

all : binary documentation

# Include other targets
!INCLUDE $(JAVAMAKEDIR)\dtargets.mak

# List dependencies here (particularly private class dependencies)

EmptySecurityManager.class : EmptySecurityManager.java

pj.lang.EmptySecurityManager.html : EmptySecurityManager.html
