##############################################################################
#
#  Copyright (c) 1996 by Dow Jones and Company, Inc.
#
#  Net.mak
#
#      Makefile for a Personal Journal Net package
#
#  Authors:
#
#      rphall   Rick Hall
#
#  Version Ident:
#
#      $Header: /PjJavaClient/src/pj/net/Net.mak 3     1/30/96 6:22p Rphall $
#
#  History:
#
#      19-Jan-96	rphall  initial creation
#
##############################################################################

# REQUIRED: define where master makefiles can be found.
# (Make definition conditional so that it can be overridden on a command line.)
!IF "$(JAVAMAKEDIR)" == ""
JAVAMAKEDIR=.\..\..
!ENDIF
!IF "$(CFG)" == ""
CFG=Java Debug
!ENDIF
!IF "$(JAVACLASSDIR)" == ""
JAVACLASSDIR=.\classes
!ENDIF
!IF "$(JAVADOCDIR)" == ""
JAVADOCDIR=.\apidocs
!ENDIF

# Include default macro definitions and generalized rules
!INCLUDE $(JAVAMAKEDIR)\defaults.mak

# List your classes here, one per line, with a backslash for continuation
CLASSES=RemoteImage.class   \
        RemoteString.class  \
        RemoteURL.class

# List the classes you want documented, one per line, with backslashes
APIDOCS=Packages-pj.net.html        \
        pj.net.RemoteImage.html     \
        pj.net.RemoteString.html    \
        pj.net.RemoteURL.html

# The default target for the build. (The first target is the Net default.)
binary : $(JAVACLASSDIR) $(CLASSES)
	for %f in ($(CLASSES)) do copy %f $(JAVACLASSDIR)

documentation : $(JAVADOCDIR) $(JAVADOCDIR)/images $(APIDOCS)
	for %f in ($(APIDOCS)) do copy %f $(JAVADOCDIR)

all : binary documentation

# Include other targets
!INCLUDE $(JAVAMAKEDIR)\dtargets.mak

# List dependencies here (particularly private class dependencies)

RemoteImage.class         : RemoteImage.java

RemoteString.class        : RemoteString.java

RemoteURL.class           : RemoteURL.java \
                            RemoteString.class

pj.net.RemoteImage.html  : RemoteImage.html

pj.net.RemoteString.html : RemoteString.html

pj.net.RemoteURL.html    : RemoteURL.html
