/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.


    @(#)Mappable.java  0.00 04-Jan-96

        Mappable objects have an object attribute
        which may be set and retrieved.

    Authors:

        rphall   Rick Hall


    Version Ident:

        $Header$


    History:

        0.00 04-Jan-96  rphall      Initial Creation

---------------------------------------------------------------------------*/

package pj.util;

import collections.ImplementationError;
import java.lang.String;

/**
 * Mappable objects have an object attribute which may be set and retrieved.
 *
 * @version 0.00 04-Jan-96
 * @author  rphall
*/
public interface Mappable extends Nameable
    {

    // --- Public operations
    /**
     * @param object The mapped object.
     * @exception ImplementationError thrown if object fails some
     * implementation-dependent test
    */
    public void setMappedObject(Object object)
        throws ImplementationError;

    /**
     * @return The mapped object.
    */
    public Object getMappedObject();

    } // Mappable
