##############################################################################
#
#  Copyright (c) Dow Jones and Company. 1995-1996. All Rights Reserved.
#
#  Util.mak
#
#      Makefile for Personal Journal utility classes.
#
#  Authors:
#
#      rphall   Rick Hall
#
#  Version Ident:
#
#      $Header: /PjJavaClient/src/pj/util/Util.mak 5     1/30/96 6:26p Rphall $
#
#  History:
#
#      0.00 28-Dec-95   rphall  initial creation
#
##############################################################################

# REQUIRED: define where master makefiles can be found.
# (Make definition conditional so that it can be overridden on a command line.)
!IF "$(JAVAMAKEDIR)" == ""
JAVAMAKEDIR=.\..\..
!ENDIF
!IF "$(CFG)" == ""
CFG=Java Debug
!ENDIF
!IF "$(JAVACLASSDIR)" == ""
JAVACLASSDIR=.\classes
!ENDIF
!IF "$(JAVADOCDIR)" == ""
JAVADOCDIR=.\apidocs
!ENDIF

# Include default macro definitions and generalized rules
!INCLUDE $(JAVAMAKEDIR)\defaults.mak

# Java binaries
CLASSES=LocalDateTime.class \
        Mappable.class \
        Nameable.class

# Documentation
APIDOCS=Packages-pj.util.html \
        pj.util.LocalDateTime.html \
        pj.util.Mappable.html \
        pj.util.Nameable.html

# The default target for the build. (The first target is the project default.)
binary : $(JAVACLASSDIR) $(CLASSES)
        for %f in ($(CLASSES)) do copy %f $(JAVACLASSDIR)

documentation : $(JAVADOCDIR) $(JAVADOCDIR)/images $(APIDOCS)
        for %f in ($(APIDOCS)) do copy %f $(JAVADOCDIR)

all : binary documentation

# Include other targets
!INCLUDE $(JAVAMAKEDIR)\dtargets.mak

# List dependencies here (particularly private class dependencies)

LocalDateTime.class : LocalDateTime.java

Mappable.class : Nameable.class

pj.util.LocalDateTime.html : LocalDateTime.html

pj.util.Mappable.html : Mappable.html

pj.util.Nameable.html : Nameable.html
